/*
 *
 * ϸ - convdb.c
 *
 *  - CrazyWWWBoard Խ  Խ ȯѴ.
 *
 *  - ѻ(bookworm@hitel.net)
 *
 * 糯 - 2000 5 18
 * ģ - 2001 5 8
 *
 * Ʒ ִ TRGTABLE, FILEDIR, TARGDIR ˸° Ͻ Ŀ Űø
 * query ִ file ǰ ÷ϵ  ġ 簡 ˴ϴ.
 *
 *    ʰ  ҽ  մϴ. عٶϴ. ׸,
 * ͸ ޸𸮿 list · 켱 Ŀ ۾ϱ  Խù 
 * ׸ŭ   ʿմϴ. (ռ 帰 ó  뵵 Ŷ
 *    ó  ʾҽϴ.)
 *
 * Ƹ ׳    , Ư  ȹ ϴ.
 * ̼ GPL̴ ʿϽø  ؼ Ͻñ ٶϴ.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define SUCCESS 1
#define FAIL 0

#define BUF_SIZE	100000

/* Խ  ̺ */
#define TRGTABLE	"dasom"
/* ÷ ִ 丮 */
#define FILEDIR		"/home/bookworm/work/crazy2js/dasom"
/* ÷  丮(  data 丮 ̰.) */
/* ۹̼ǿ ϼ. */
#define TARGDIR		"/home/www/jsboard/data/dasom/files"

/* Խù  ϱ   */
typedef struct struct_article
{
    int idnumber;					/* Խù ȣ */
    time_t date;					/* ԽϽ */
    char host[25];					/* ۾ IP */
    char name[100];					/* ̸ */
    char email[100];				/* ̸ ּ */
    char subject[300];				/*  */
    char *text;						/*  */
    unsigned int refer;				/* ȸ */
    int reno;						/* θ Խù ȣ */
    char bofile[100];				/* ÷ ϸ */
	char bcfile[100];				/* ÷   丮 */
    int bfsize;						/* ÷  ũ */
	unsigned int checked;
	struct struct_article *next;	/*    */
} ARTICLE;

/* Խù  Ʈ ó   */
ARTICLE *listhead = NULL, *listtail = NULL;

ARTICLE *plist;

int start_num;	/* Խù  ȣ. no column    κ
				   ۵Ǹ, ̸ ϸ Խ merge   ִ. */

int rede = 0;	/* Խù . 0 ֻ  */
int reto = 0;	/*   θ  idnumber */

int idx;		/* idx column  counter. idx column  ȭ鿡 Ÿ
				   Խù  ϴµ ȴ. */

int num;

/*    иѴ */
void get_value(char *buf, int *idnumber, char *itemname, char *value);
/* %xx -> '?'  ڵ Ѵ */
void decode_string(char *src, char *dest);
/* idnumber  ϴ  ͸ ã´.   带  */
ARTICLE *search_idnumber(int idnumber);
/* Ʈ Ѵ */
void free_list();
/*  忡  Ѵ */
int set_value(ARTICLE *plist, char *itemname, char *decoded_value);
/* query  Ѵ. */
int print_query(int idnumber);
/* ÷  Ѵ. */
int copy_attch_file(char *dir, char *file);
/* ܼ   */
int copy_file(char *targ_file, char *src_file);
/*  ִ date ڿ  Ѵ. */
void repair_date_err(char *date);

/* ü  켱  ͸ о,     ϴ
 * linked list  Ѵ. , ֻ(depth 0) ͸ 
 *  , ۿ  (depth 1  ) ͸  Ѵ.
 * ̶ ۿ   ִ Ȯؼ  ִٸ,   Ѵ.
 * ̷     µɶ ݺѴ.
 */

int main(int argc, char *argv[])
{
	FILE *fp;
	char buf[BUF_SIZE];

	int idnumber;
	char itemname[30];
	char value[BUF_SIZE];
	char decoded_value[BUF_SIZE];
	ARTICLE *p;
	int exist_thread;

    if (argc < 2 || argc > 3)
    {
		fprintf(stderr, " : %s <ϸ> [ ȣ]\n", argv[0]);
	
		return EXIT_FAILURE;
	}

	idx = start_num = 0;

	if (argc == 3)	/* ' ȣ' ɼ  */
	{
		start_num = atoi(argv[2]);
		
		if (start_num <= 0)
		{
			fprintf(stderr, " : %s <ϸ> [ ȣ]\n", argv[0]);
		
			return EXIT_FAILURE;
		}
	}
	
	if ((fp = fopen(argv[1], "r")) == NULL)
	{
		fprintf(stderr, "File open error.\n");
		return EXIT_FAILURE;
	}
	
	/*    о, list  */
	while (fgets(buf, BUF_SIZE - 1, fp) != NULL)
	{
		get_value(buf, &idnumber, itemname, value);
		decode_string(value, decoded_value);
		idnumber += start_num;
		p = search_idnumber(idnumber);
		set_value(p, itemname, decoded_value);
	}

	p = listhead;
	
	num = 1;
	while (p != NULL)
	{
		if (p->idnumber != 0 && p->reno == 0)
		{
			/*  Ʒʿ ġϱ   query  Ѵ. */
			exist_thread = print_query(p->idnumber);

			if (p->bfsize <= 0)
				printf("INSERT %s (no, num, idx, date, host, name, email, "
				"title, text,refer, reno, rede, reto) VALUES (%d, %d, %d, %d, "
				"'%s', '%s', '%s', '%s', '%s', %d, 0, 0, 0);\n\n", 
				TRGTABLE, p->idnumber, num, idx, (int) p->date, p->host, 
				p->name, p->email, p->subject, p->text, p->refer);
			else
			{
				printf("INSERT %s (no, num, idx, date, host, name, email, "
				"title, text,refer, reno, rede, reto, bofile, bcfile, bfsize) "
				"VALUES (%d, %d, %d, %d, '%s', '%s', '%s', '%s', '%s', %d, 0, "
				"0, 0, '%s','%s', %d);\n\n",
				TRGTABLE, p->idnumber, num, idx, (int) p->date, p->host, 
				p->name, p->email, p->subject, p->text, p->refer, p->bofile, 
				p->bcfile, p->bfsize);

				copy_attch_file(p->bcfile, p->bofile);
			}
			
			idx++;
			num++;

			if (exist_thread)
				printf("UPDATE %s SET reyn = 1 WHERE no = %d;\n", TRGTABLE, 
				p->idnumber);
		}
		p = p->next;
	}

	if (fclose(fp))
	{
		fprintf(stderr, "File close error.\n");
		return EXIT_FAILURE;
	}
	
	free_list();

	return EXIT_SUCCESS;
}

/*  Ϳ ۹ȣ, ׸,  иѴ. */
void get_value(char *buf, int *idnumber, char *itemname, char *value)
{
	char tmp_number[30];
	char *pbuf = buf, *ptmp_number = tmp_number, *pitemname = itemname;
	char *pvalue = value;
	
	/* (idnumber) Ѵ */
	while (isdigit(*pbuf))
		*ptmp_number++ = *pbuf++;
	*ptmp_number = '\0';
	
	*idnumber = atoi(tmp_number);
	
	/* ڸ   */
	if (*idnumber == 0)
	{
		*itemname = *value = '\0';
		return;
	}
	
	/* '.' Ȯ */
	if (*pbuf != '.')
	{
		*idnumber = 0;
		*itemname = *value = '\0';
		return;
	}
	else
		pbuf++;
	
	/* ׸(itemname) Ѵ */
	while (*pbuf != '=')
		*pitemname++ = *pbuf++;
	*pitemname = '\0';
	pbuf++;
	
	/*   value Ѵ */
	while (*pbuf != '\0')
		*pvalue++ = *pbuf++;
	*pvalue = '\0';
}	/* of get_value */

/* 16   10 ȯѴ. */
int hex2dec(char hex)
{
	if (isdigit(hex))
		return hex - '0';
	else
		return tolower(hex) - 'a' + 10;
}

/* ȣ HTML Ư ȣ ȯѴ. */
int txt2html(char *ch)
{
	switch (*ch)
	{
		case '&' :	
			strcpy(ch, "&amp;");
			return 5;
		case '"' :
			strcpy(ch, "&quot;");
			return 6;
		case '<' :
			strcpy(ch, "&lt;");
			return 4;
		case '>' :
			strcpy(ch, "&gt;");
			return 4;
		case '\'' :
			strcpy(ch, "\\'");
			return 2;
		case '\\' :
			strcpy(ch, "\\\\");
			return 2;
	}
	
	return 1;
}

/* encode  ڿ decode Ѵ. encode %xx ̸, xx 16̴. */
void decode_string(char *src, char *dest)
{
	char *psrc = src, *pdest = dest;

	while (*psrc != '\0')
		if (*psrc == '%')
		{
			*pdest = hex2dec(*(psrc + 1)) * 16 + hex2dec(*(psrc + 2));
			pdest += txt2html(pdest);	
			psrc += 3;
		}
		else
			if (*psrc == '+')
			{
				+*pdest++ = ' ';
				psrc++;
			}
			else
				*pdest++ = *psrc++;
	*pdest = '\0';
}	/* of decode_string */

/* ۹ȣ idnumber  node ãƼ ͸ Ѵ.  node 
 * ο node Ҵϰ,  ͸ Ѵ. */
ARTICLE *search_idnumber(int idnumber)
{
	ARTICLE *tmp;
	ARTICLE *old_plist = NULL;
	plist = listhead;
	
	while (plist != NULL)
	{
		if (plist->idnumber == idnumber)
			return plist;
		
		if (plist->idnumber > idnumber)
		{
			if ((tmp = (ARTICLE *) malloc(sizeof(ARTICLE))) == NULL)
			{
				fprintf(stderr, " : ޸ \n");
				exit(1);
			}
			if (old_plist != NULL)
				old_plist->next = tmp;
			else
				listhead = tmp;
			bzero(tmp, sizeof(ARTICLE));
			tmp->idnumber = idnumber;
			tmp->reno = 0;
			tmp->checked = 0;
			tmp->next = plist;
			
			return tmp;
		}

		old_plist = plist;
		plist = plist->next;
	}
	
	if (listhead == NULL)
	{
		if ((plist = (ARTICLE *) malloc(sizeof(ARTICLE))) == NULL)
		{
			fprintf(stderr, " : ޸ \n");
			exit(1);
		}
		listhead = listtail = plist;
		bzero(plist, sizeof(ARTICLE));
		plist->idnumber = idnumber;
		plist->reno = 0;
		plist->checked = 0;
		plist->next = NULL;
		
		return plist;
	}

	if ((tmp = (ARTICLE *) malloc(sizeof(ARTICLE))) == NULL)
	{
		fprintf(stderr, " : ޸ \n");
		exit(1);
	}
	old_plist->next = tmp;
	bzero(tmp, sizeof(ARTICLE));
	tmp->idnumber = idnumber;
	tmp->reno = 0;
	tmp->checked = 0;
	tmp->next = NULL;
	listtail = tmp;
	
	return tmp;
}

void free_list()
{
	ARTICLE *tmp;
	
	plist = listhead;
	
	while (plist != NULL)
	{
		tmp = plist;
		plist = plist->next;
		free(tmp->text);		/*   Ҵ ޸  */
		free(tmp);
	}
}

/* itemname  node  Ѵ. */
int set_value(ARTICLE *plist, char *itemname, char *decoded_value)
{
	char *p;
	struct tm datetime;		/*   ð  ü */
	char tmp[5];			/* ڿ ð  ٲٱ  ӽ 迭 */

	assert(plist != NULL && itemname != NULL && decoded_value != NULL);
	
	p = decoded_value + strlen(decoded_value) - 1;

	if (*p == '\n')
		*p = '\0';

	if (strcmp("Date", itemname) == 0)
	{
		repair_date_err(decoded_value);

		/* CrazyWWWBoard    ð JSBoard ÷ 丮  */
		strcpy(plist->bcfile, decoded_value);

		datetime.tm_isdst = 0;			/* Daylight Saving Time  */

		/*  */
		*tmp = *decoded_value;
		*(tmp + 1) = *(decoded_value + 1);
		*(tmp + 2) = *(decoded_value + 2);
		*(tmp + 3) = *(decoded_value + 3);
		*(tmp + 4) = '\0';

		datetime.tm_year = atoi(tmp);	/* ⵵ ڷ ȯϿ  */
		datetime.tm_year -= 1900;		/* mktime Լ ° ȯ */

		/*  */
		*tmp = *(decoded_value + 4);
		*(tmp + 1) = *(decoded_value + 5);
		*(tmp + 2) = '\0';
		datetime.tm_mon = atoi(tmp);	/*  ڷ ȯϿ  */
		datetime.tm_mon--;

		/*  */
		*tmp = *(decoded_value + 6);
		*(tmp + 1) = *(decoded_value + 7);
		*(tmp + 2) = '\0';
		datetime.tm_mday = atoi(tmp);	/*  ڷ ȯϿ  */

		/*  */
		*tmp = *(decoded_value + 8);
		*(tmp + 1) = *(decoded_value + 9);
		*(tmp + 2) = '\0';
		datetime.tm_hour = atoi(tmp);	/* ø ڷ ȯϿ  */

		/*  */
		*tmp = *(decoded_value + 10);
		*(tmp + 1) = *(decoded_value + 11);
		*(tmp + 2) = '\0';
		datetime.tm_min = atoi(tmp);	/*  ڷ ȯϿ  */

		/*  */
		*tmp = *(decoded_value + 12);
		*(tmp + 1) = *(decoded_value + 13);
		*(tmp + 2) = '\0';
		datetime.tm_sec = atoi(tmp);	/* ʸ ڷ ȯϿ  */

		plist->date = mktime(&datetime);

		return SUCCESS;
	}
	if (strcmp("IP", itemname) == 0)
	{
		strcpy(plist->host, decoded_value);
		return SUCCESS;
	}
	if (strcmp("Name", itemname) == 0)
	{
		strcpy(plist->name, decoded_value);
		return SUCCESS;
	}
	if (strcmp("Email", itemname) == 0)
	{
		strcpy(plist->email, decoded_value);
		return SUCCESS;
	}
	if (strcmp("Subject", itemname) == 0)
	{
		strcpy(plist->subject, decoded_value);
		return SUCCESS;
	}
	if (strcmp("Text", itemname) == 0)
	{
		/*  ϱ  ޸ Ҵ */
		if ((plist->text = (char *) malloc(strlen(decoded_value) + 1)) == NULL)
		{
			fprintf(stderr, " : ޸ ");
			exit(1);
		}
		strcpy(plist->text, decoded_value);
		for (p = plist->text; *p != '\0'; p++)
			if (*p == '\r' && *(p + 1) == '\x0a')
				*p = ' ';

		return SUCCESS;
	}
	if (strcmp("Access", itemname) == 0)
	{
		plist->refer = atoi(decoded_value);
		return SUCCESS;
	}
	if (strcmp("Thread", itemname) == 0)
	{
		plist->reno = atoi(decoded_value);
		return SUCCESS;
	}
	if (strcmp("Filename", itemname) == 0)
	{
		strcpy(plist->bofile, decoded_value);
		return SUCCESS;
	}
	if (strcmp("Filesize", itemname) == 0)
	{	
		plist->bfsize = atoi(decoded_value);
		return SUCCESS;
	}
	
	return FAIL;
}	/* of set_value */

/*   query ϴ Լ̴.
 * idnumber ޾Ƽ   شϴ  θ  ۵ ãƼ query
 * Ѵ.   ٽ θ Ǽ print_query Լ  ۵
 * query ϵ Ǿִ.
 *
 * idnumber شϴ    1,  0 Ѵ. */
int print_query(int idnumber)
{
	int reyn = 0;
	int i;
	ARTICLE *plist;
	int exist_thread;

	rede++;
	
	if (rede == 1)
		reto = idnumber;

	plist = listhead;
	while (plist != NULL)
	{
		if (plist->reno == idnumber && plist->checked == 0)
		{
			exist_thread = print_query(plist->idnumber);

			plist->checked = 1;
			reyn = 1;
			for (i = 0; i < rede; i++)
				putchar('\t');

			if (plist->bfsize <= 0)
				printf("INSERT %s (no, num, idx, date, host, name, email, "
				"title, text, refer, reno, rede, reto) VALUES (%d, %d, %d, %d, "
				"'%s', '%s', '%s', '%s', '%s', %d, %d, %d, %d);\n\n", 
				TRGTABLE, plist->idnumber, 0, idx, (int) plist->date, 
				plist->host, plist->name, plist->email, plist->subject, 
				plist->text, plist->refer, idnumber, rede, reto);
			else
			{
				printf("INSERT %s (no, num, idx, date, host, name, email, "
				"title, text, refer, reno, rede, reto, bofile, bcfile, bfsize) "
				"VALUES (%d, %d, %d, %d, '%s', '%s', '%s', '%s', '%s', %d, %d, "
				"%d, %d, '%s', '%s', %d);\n\n",
				TRGTABLE, plist->idnumber, 0, idx, (int) plist->date, 
				plist->host, plist->name, plist->email, plist->subject, 
				plist->text, plist->refer, idnumber, rede, reto, plist->bofile,
				plist->bcfile, plist->bfsize);
				
				copy_attch_file(plist->bcfile, plist->bofile);
			}

			idx++;

			if (exist_thread)
				printf("UPDATE %s SET reyn = 1 WHERE no = %d;\n",
						TRGTABLE, plist->idnumber);
		}

		plist = plist->next;
	}
	
	if (rede == 1)
		reto = 0;
	
	rede--;

	return reyn;
}

/* dir YYYYMMDDHHMMSS  ڿ̸, file  丮 ̴. */
int copy_attch_file(char *dir, char *file)
{
	char src_file[256] = FILEDIR;
	char targ_file[256] = TARGDIR;

	assert(dir != NULL && file != NULL);

	strcat(targ_file, "/");
	strcat(targ_file, dir);

	if (mkdir(targ_file, 0755) != 0)
		fprintf(stderr, ": %s 丮  ߽ϴ.\n", src_file);

	strcat(src_file, "/");
	strcat(src_file, file);

	strcat(targ_file, "/");
	strcat(targ_file, file);

	if (copy_file(targ_file, src_file) != 0)
		fprintf(stderr, " : %s ÷  ߽ϴ.\n", src_file);

	return 0;
}

/* targ_file, src_file  Full patname 䱸ȴ. */
int copy_file(char *targ_file, char *src_file)
{
	int src_fd, targ_fd;
	char buf[BUFSIZ];
	int read_size;

	assert(targ_file != NULL && src_file != NULL);

	if ((src_fd = open(src_file, O_RDONLY)) == -1)
		return 1;
	if ((targ_fd = creat(targ_file, 0644)) == -1) 
		return 1;

	while ((read_size = read(src_fd, buf, BUFSIZ)) > 0)
		if (write(targ_fd, buf, read_size) != read_size)
			return 1;

	return 0;
}

/* CrazyWWWBoard Ѿ date   ģ.
 * 
 * tranDB ؼ ȯ ASCII    Date ׸  ܿ
 *  '+' ȣ ԵǾִ. ̰ decode  ġ鼭 ' ' ȯȴ.
 * ⼭ ' ' 0 Ͽ Ѵ.
 *
 */
void repair_date_err(char *date)
{
	char *p = date;

	assert(date != NULL);

	while (*p != '\0')
	{
		if (*p == ' ')
			*p = 0;
		p++;
	}
}

